window.Gleam.initSearch([{"doc":"antigone","title":"antigone","content":"# antigone\n\nArgon2 password hashing for Gleam.\n\n[![Package Version](https://img.shields.io/hexpm/v/antigone)](https://hex.pm/packages/antigone)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/antigone/)\n\nThis package uses the [elixir_argon2](https://github.com/riverrun/argon2_elixir)\nlibrary, so you will need to have Elixir installed and be running on Erlang to\nuse this package.\n\n```sh\ngleam add antigone\n```\n```gleam\nimport antigone\n\npub fn main() {\n  // You&#39;ve got a password or token you wish to hash so that you can verify it\n  // later without having to store the password or hash itself.\n  let password = &quot;blink182&quot;\n\n  // Hash the password with the default configuration:\n  antigone.hash(antigone.hasher(), password)\n  // -&gt; &quot;$argon2id$v=19$m=65536,t=3,p=4$h1bn4Va1EXJ+kReN0/q45Q$KMj1OQV0tueWPFKw97bB+RVGsYgdPpiVxZibzbc3dBw&quot;\n\n  // Alternatively you can specify your own configuration.\n  // Here we are lowering the costs to make the hashing faster. You may want to\n  // do this in your tests, but you must never do this in production.\n  antigone.hasher()\n  |&gt; antigone.time_cost(1)\n  |&gt; antigone.memory_cost(8)\n  |&gt; antigone.hash(password)\n  // -&gt; &quot;$argon2id$v=19$m=256,t=1,p=4$Q7MevutDdDKNtKFvygG7QQ$Ta+IOOaBq6iOfvUqBvehHmnVUzjpzOV7g3B+3VKqLfo&quot;\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/antigone&gt;.\n\n### Why it is called Antigone?\n\nI really liked X2: The Threat as a kid.\n","url":"index.html"},{"doc":"antigone","title":"Argon2Type","content":"pub type Argon2Type {\n  Argon2d\n  Argon2i\n  Argon2id\n}\n\nArgon2d\n Suitable for applications with no threats from side-channel timing attacks (eg. cryptocurrencies)\n\nArgon2i\n Suitable for password hashing and password-based key derivation.\n\nArgon2id\n A hybrid of Argon2d and Argon2i. The default type.\n\nSynonyms:\nantigone.Argon2Type\nantigone Argon2Type","url":"antigone.html#Argon2Type"},{"doc":"antigone","title":"Hasher","content":"pub opaque type Hasher\n\n\nSynonyms:\nantigone.Hasher\nantigone Hasher","url":"antigone.html#Hasher"},{"doc":"antigone","title":"argon2_type","content":"pub fn argon2_type(\n  hasher: Hasher,\n  argon2_type: Argon2Type,\n) -&gt; Hasher\n The Argon2 type to use. The default is Argon2id.\n\nSynonyms:\nantigone.argon2_type\nantigone argon2_type","url":"antigone.html#argon2_type"},{"doc":"antigone","title":"fake_verify","content":"pub fn fake_verify(hasher: Hasher) -&gt; Nil\n Runs the password hash function but doesn&#39;t return any data.\n\n This function is intended to make it more difficult for any potential\n attacker to find valid usernames by using timing attacks. This function\n is only useful if it is used as part of a policy of hiding usernames.\n\nSynonyms:\nantigone.fake_verify\nantigone fake_verify","url":"antigone.html#fake_verify"},{"doc":"antigone","title":"hash","content":"pub fn hash(hasher: Hasher, data: BitArray) -&gt; String\n Hash the given data with a randomly generated salt.\n\nSynonyms:\nantigone.hash\nantigone hash","url":"antigone.html#hash"},{"doc":"antigone","title":"hash_length","content":"pub fn hash_length(hasher: Hasher, hash_length: Int) -&gt; Hasher\n The length of the hash in bytes.\n\nSynonyms:\nantigone.hash_length\nantigone hash_length","url":"antigone.html#hash_length"},{"doc":"antigone","title":"hasher","content":"pub fn hasher() -&gt; Hasher\n Create a new hasher with the default configuration. This can then be\n optionally configured with the various functions of this module, and then\n used to hash data with the `hash` function.\n\nSynonyms:\nantigone.hasher\nantigone hasher","url":"antigone.html#hasher"},{"doc":"antigone","title":"memory_cost","content":"pub fn memory_cost(hasher: Hasher, memory_cost: Int) -&gt; Hasher\n The memory usage cost, given in kibibytes.\n\n The default value is 16, this will produce a memory usage of 64 MiB (2 ^ 16\n KiB). In your tests you may to decrease this value to 8 so your tests will\n use less memory. You must not decrease this value in production.\n\nSynonyms:\nantigone.memory_cost\nantigone memory_cost","url":"antigone.html#memory_cost"},{"doc":"antigone","title":"parallelism","content":"pub fn parallelism(hasher: Hasher, parallelism: Int) -&gt; Hasher\n The number of threads that the algorithm will use.\n\n The default value is 4.\n\nSynonyms:\nantigone.parallelism\nantigone parallelism","url":"antigone.html#parallelism"},{"doc":"antigone","title":"time_cost","content":"pub fn time_cost(hasher: Hasher, time_cost: Int) -&gt; Hasher\n The time cost is the number of iterations that the algorithm will\n perform.\n\n The default value is 3. In your tests you may to decrease this value to 1 so\n your tests run faster. You must not decrease this value in production.\n\nSynonyms:\nantigone.time_cost\nantigone time_cost","url":"antigone.html#time_cost"},{"doc":"antigone","title":"verify","content":"pub fn verify(data: BitArray, hash: String) -&gt; Bool\n Verify in constant time that the given data matches the given hash.\n\nSynonyms:\nantigone.verify\nantigone verify","url":"antigone.html#verify"},{"doc":"antigone","title":"antigone","content":" Argon2 is the winner of the [Password Hashing Competition (PHC)](https://password-hashing.net).\n\n Argon2 is a memory-hard password hashing function which can be used to hash\n passwords for credential storage, key derivation, or other applications.\n\n Argon2 has the following three variants (Argon2id is the default):\n\n - Argon2d - suitable for applications with no threats from side-channel\n   timing attacks (eg. cryptocurrencies)\n - Argon2i - suitable for password hashing and password-based key derivation\n - Argon2id - a hybrid of Argon2d and Argon2i\n\n Argon2i, Argon2d, and Argon2id are parametrized by:\n\n - A **time** cost, which defines the amount of computation realized and\n   therefore the execution time, given in number of iterations\n - A **memory** cost, which defines the memory usage, given in kibibytes\n - A **parallelism** degree, which defines the number of parallel threads\n\n More information can be found at the [Argon2 reference C implementation\n repository](https://github.com/P-H-C/phc-winner-argon2) and in the\n documentation for the [elixir_argon2](https://hex.pm/packages/argon2_elixir)\n package.\n\n ## Comparison with Bcrypt / Pbkdf2\n\n Argon2 has better password cracking resistance than Bcrypt and Pbkdf2.\n Its main advantage is that, as it is a memory-hard function, it is designed\n to withstand parallel attacks that use GPUs or other dedicated hardware.","url":"antigone.html"}]);